%ifnarch %{ocaml_native_compiler}
%global debug_package %{nil}
%endif

%global srcname fmt

Name:           ocaml-%{srcname}
Version:        0.9.0
Release:        %mkrel 1
Summary:        OCaml Format pretty-printer combinators
Group:          Development/OCaml

License:        ISC
URL:            https://erratique.ch/software/fmt
Source0:        https://github.com/dbuenzli/fmt/archive/v%{version}/%{srcname}-%{version}.tar.gz

BuildRequires:  ocaml >= 4.08.0
BuildRequires:  ocaml-cmdliner-devel >= 0.9.8
BuildRequires:  ocaml-findlib
BuildRequires:  ocaml-ocamlbuild
BuildRequires:  ocaml-compiler
BuildRequires:  ocaml-ocamldoc
BuildRequires:  ocaml-topkg-devel >= 1.0.3

%description
Fmt exposes combinators to devise `Format` pretty-printing functions.

Fmt depends only on the OCaml standard library.  The optional Fmt_tty
library that enables setting up formatters for terminal color output
depends on the Unix library.  The optional Fmt_cli library that provides
command line support for Fmt depends on Cmdliner.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%prep
%autosetup -n %{srcname}-%{version} -p1

# Skip the styled_perf_bug test, which runs until stopped by an external signal
sed -i '/styled_perf_bug/d' pkg/pkg.ml _tags

# link with the math library
echo $'\ntrue: cclib(-lm)' >> _tags

# Topkg does watermark replacements only if run inside a git checkout.  Github
# tarballs do not come with a .git directory.  Therefore, we do the watermark
# replacement manually.
for fil in $(find . -type f); do
  sed -e 's,%%%%NAME%%%%,%{srcname},' \
      -e 's,%%%%VERSION%%%%,v%{version},' \
      -e 's,%%%%VERSION_NUM%%%%,%{version},' \
      -i.orig $fil
  touch -r $fil.orig $fil
  rm $fil.orig
done

%build
# Build the library and the tests
ocaml pkg/pkg.ml build --tests true --with-base-unix true --with-cmdliner true

# Build the documentation
mkdir html
ocamldoc -html -d html -I +cmdliner -I _build/src _build/src/*.mli

%install
# Install the library
mkdir -p %{buildroot}%{_libdir}/ocaml/fmt
cp -p _build/{opam,pkg/META} %{buildroot}%{_libdir}/ocaml/fmt
%ifarch %{ocaml_native_compiler}
cp -a _build/src/*.{a,cma,cmi,cmt,cmti,cmx,cmxa,cmxs,mli} \
  %{buildroot}%{_libdir}/ocaml/fmt
%else
cp -a _build/src/*.{cma,cmi,cmt,cmti,mli} %{buildroot}%{_libdir}/ocaml/fmt
%endif

%check
ocaml pkg/pkg.ml test

%files
%doc CHANGES.md README.md
%license LICENSE.md
%dir %{_libdir}/ocaml/%{srcname}/
%{_libdir}/ocaml/%{srcname}/META
%{_libdir}/ocaml/%{srcname}/%{srcname}*.cma
%{_libdir}/ocaml/%{srcname}/%{srcname}*.cmi
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{srcname}/%{srcname}*.cmxs
%endif

%files devel
%doc html/*
%{_libdir}/ocaml/%{srcname}/opam
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{srcname}/%{srcname}*.a
%{_libdir}/ocaml/%{srcname}/%{srcname}*.cmx
%{_libdir}/ocaml/%{srcname}/%{srcname}*.cmxa
%endif
%{_libdir}/ocaml/%{srcname}/%{srcname}*.cmt
%{_libdir}/ocaml/%{srcname}/%{srcname}*.cmti
%{_libdir}/ocaml/%{srcname}/%{srcname}*.mli



%changelog
* Sat Oct 08 2022 pterjan <pterjan> 0.9.0-1.mga9
+ Revision: 1895581
- Disable broken test
- Update to 0.9.0

* Thu May 19 2022 pterjan <pterjan> 0.8.10-2.mga9
+ Revision: 1859173
- Rebuild for OCaml 4.14

* Wed Oct 13 2021 tv <tv> 0.8.10-1.mga9
+ Revision: 1751062
- Version 0.8.10
- Drop upstreamed -stdlib-shims patch
- OCaml 4.13.1 build

* Fri Mar 05 2021 tv <tv> 0.8.9-1.mga9
+ Revision: 1699888
- 0.8.9

* Sun Jan 10 2021 pterjan <pterjan> 0.8.8-0.4.mga8
+ Revision: 1670664
- Rebuild to generate ocamlx provides

* Fri Feb 28 2020 umeabot <umeabot> 0.8.8-0.3.mga8
+ Revision: 1551656
- Rebuild for ocaml 4.10.0 final

* Thu Feb 20 2020 umeabot <umeabot> 0.8.8-0.2.mga8
+ Revision: 1545754
- Mageia 8 Mass Rebuild

* Wed Jan 29 2020 tv <tv> 0.8.8-0.1.mga8
+ Revision: 1485158
- imported package ocaml-fmt

